<html>
<head>
<title>OgrePredefinedControllers.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgrePredefinedControllers.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgrePredefinedControllers_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __PredefinedControllers_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __PredefinedControllers_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreController_8h.html">OgreController.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreFrameListener_8h.html">OgreFrameListener.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreGpuProgram_8h.html">OgreGpuProgram.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00046"></a>00046     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00047"></a>00047     <span class="comment">// Controller Values</span>
<a name="l00048"></a>00048     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00051"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html">00051</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html" title="Predefined controller value for getting the latest frame time.">FrameTimeControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;, <span class="keyword">public</span> <a class="code" href="classOgre_1_1FrameListener.html" title="A interface class defining a listener which can be used to receive notifications of frame events...">FrameListener</a>
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053     <span class="keyword">protected</span>:
<a name="l00054"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#aab120ed336d85b375181a9a75b0fe6eb">00054</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html#aab120ed336d85b375181a9a75b0fe6eb">mFrameTime</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#a9cc9de7e8a4cf00a493bb356600e5689">00055</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html#a9cc9de7e8a4cf00a493bb356600e5689">mTimeFactor</a>;
<a name="l00056"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#adcd30d981a8e3012b4f4fff7494cf8ae">00056</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html#adcd30d981a8e3012b4f4fff7494cf8ae">mElapsedTime</a>;
<a name="l00057"></a><a class="code" href="classOgre_1_1FrameTimeControllerValue.html#a6b3645fb30af84e4b553d00f7b19e293">00057</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1FrameTimeControllerValue.html#a6b3645fb30af84e4b553d00f7b19e293">mFrameDelay</a>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a>00060         <a class="code" href="classOgre_1_1FrameTimeControllerValue.html" title="Predefined controller value for getting the latest frame time.">FrameTimeControllerValue</a>();
<a name="l00061"></a>00061         <span class="keywordtype">bool</span> frameEnded(<span class="keyword">const</span> <a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a> &amp;evt);
<a name="l00062"></a>00062         <span class="keywordtype">bool</span> frameStarted(<span class="keyword">const</span> <a class="code" href="structOgre_1_1FrameEvent.html" title="Struct containing information about a frame event.">FrameEvent</a> &amp;evt);
<a name="l00063"></a>00063         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00064"></a>00064         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00065"></a>00065         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTimeFactor(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00066"></a>00066         <span class="keywordtype">void</span> setTimeFactor(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> tf);
<a name="l00067"></a>00067         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getFrameDelay(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00068"></a>00068         <span class="keywordtype">void</span> setFrameDelay(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> fd);
<a name="l00069"></a>00069         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getElapsedTime(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00070"></a>00070         <span class="keywordtype">void</span> setElapsedTime(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> elapsedTime);
<a name="l00071"></a>00071     };
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00076"></a><a class="code" href="classOgre_1_1TextureFrameControllerValue.html">00076</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TextureFrameControllerValue.html" title="Predefined controller value for getting / setting the frame number of a texture layer.">TextureFrameControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078     <span class="keyword">protected</span>:
<a name="l00079"></a><a class="code" href="classOgre_1_1TextureFrameControllerValue.html#aeff61a7e6136ed9752af3d1c5a29e69d">00079</a>         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* <a class="code" href="classOgre_1_1TextureFrameControllerValue.html#aeff61a7e6136ed9752af3d1c5a29e69d">mTextureLayer</a>;
<a name="l00080"></a>00080     <span class="keyword">public</span>:
<a name="l00081"></a>00081         <a class="code" href="classOgre_1_1TextureFrameControllerValue.html" title="Predefined controller value for getting / setting the frame number of a texture layer.">TextureFrameControllerValue</a>(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* t);
<a name="l00082"></a>00082 
<a name="l00085"></a>00085         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00088"></a>00088         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     };
<a name="l00091"></a>00091     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00100"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html">00100</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html" title="Predefined controller value for getting / setting a texture coordinate modifications (scales and tran...">TexCoordModifierControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102     <span class="keyword">protected</span>:
<a name="l00103"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#aab6d38dbbf644c1f0cbb4c8d8d1bfc34">00103</a>         <span class="keywordtype">bool</span> mTransU, <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#aab6d38dbbf644c1f0cbb4c8d8d1bfc34">mTransV</a>;
<a name="l00104"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#a20b840b0a76e3d58e1e02b903f41c870">00104</a>         <span class="keywordtype">bool</span> mScaleU, <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#a20b840b0a76e3d58e1e02b903f41c870">mScaleV</a>;
<a name="l00105"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#aa5e4efb0c4b4fbac5f7042e267deedce">00105</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#aa5e4efb0c4b4fbac5f7042e267deedce">mRotate</a>;
<a name="l00106"></a><a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#a6f82b544431b95702d692e56892e2675">00106</a>         <a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html#a6f82b544431b95702d692e56892e2675">mTextureLayer</a>;
<a name="l00107"></a>00107     <span class="keyword">public</span>:
<a name="l00122"></a>00122         <a class="code" href="classOgre_1_1TexCoordModifierControllerValue.html" title="Predefined controller value for getting / setting a texture coordinate modifications (scales and tran...">TexCoordModifierControllerValue</a>(<a class="code" href="classOgre_1_1TextureUnitState.html" title="Class representing the state of a single texture unit during a Pass of a Technique, of a Material.">TextureUnitState</a>* t, <span class="keywordtype">bool</span> translateU = <span class="keyword">false</span>, <span class="keywordtype">bool</span> translateV = <span class="keyword">false</span>,
<a name="l00123"></a>00123             <span class="keywordtype">bool</span> scaleU = <span class="keyword">false</span>, <span class="keywordtype">bool</span> scaleV = <span class="keyword">false</span>, <span class="keywordtype">bool</span> rotate = <span class="keyword">false</span> );
<a name="l00124"></a>00124 
<a name="l00125"></a>00125         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00126"></a>00126         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     };
<a name="l00129"></a>00129 
<a name="l00130"></a>00130     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00143"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html">00143</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html" title="Predefined controller value for setting a single floating- point value in a constant parameter of a v...">FloatGpuParameterControllerValue</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerValue.html" title="Can either be used as an input or output value.">ControllerValue</a>&lt;Real&gt;
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145     <span class="keyword">protected</span>:
<a name="l00147"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#aa94619d78ae3797cc876d6ab9ed5f1bc">00147</a>         <a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#aa94619d78ae3797cc876d6ab9ed5f1bc" title="The parameters to access.">mParams</a>;
<a name="l00149"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#ab5735fd67d4c023ecadbc5ec7cc3afd2">00149</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#ab5735fd67d4c023ecadbc5ec7cc3afd2" title="The index of the parameter to e read or set.">mParamIndex</a>;
<a name="l00150"></a>00150     <span class="keyword">public</span>:
<a name="l00157"></a>00157         <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html" title="Predefined controller value for setting a single floating- point value in a constant parameter of a v...">FloatGpuParameterControllerValue</a>(<a class="code" href="classOgre_1_1SharedPtr.html">GpuProgramParametersSharedPtr</a> params,
<a name="l00158"></a>00158                 <span class="keywordtype">size_t</span> index );
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#a4cd25fecd64c347a91c5277f4bfebbce">00160</a>         <a class="code" href="classOgre_1_1FloatGpuParameterControllerValue.html#a4cd25fecd64c347a91c5277f4bfebbce">~FloatGpuParameterControllerValue</a>() {}
<a name="l00161"></a>00161 
<a name="l00162"></a>00162         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getValue(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00163"></a>00163         <span class="keywordtype">void</span> setValue(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> value);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     };
<a name="l00166"></a>00166     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00167"></a>00167     <span class="comment">// Controller functions</span>
<a name="l00168"></a>00168     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classOgre_1_1PassthroughControllerFunction.html">00173</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1PassthroughControllerFunction.html" title="Predefined controller function which just passes through the original source directly to dest...">PassthroughControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>&lt;Real&gt;
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175     <span class="keyword">public</span>:
<a name="l00182"></a>00182         <a class="code" href="classOgre_1_1PassthroughControllerFunction.html" title="Predefined controller function which just passes through the original source directly to dest...">PassthroughControllerFunction</a>(<span class="keywordtype">bool</span> deltaInput = <span class="keyword">false</span>);
<a name="l00183"></a>00183 
<a name="l00186"></a>00186         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00187"></a>00187     };
<a name="l00188"></a>00188 
<a name="l00191"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html">00191</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1AnimationControllerFunction.html" title="Predefined controller function for dealing with animation.">AnimationControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>&lt;Real&gt;
<a name="l00192"></a>00192     {
<a name="l00193"></a>00193     <span class="keyword">protected</span>:
<a name="l00194"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html#ab3a5975d6690d692328942935fc298a5">00194</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1AnimationControllerFunction.html#ab3a5975d6690d692328942935fc298a5">mSeqTime</a>;
<a name="l00195"></a><a class="code" href="classOgre_1_1AnimationControllerFunction.html#a7ec76f22736a88f3362e007f87f514ae">00195</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1AnimationControllerFunction.html#a7ec76f22736a88f3362e007f87f514ae">mTime</a>;
<a name="l00196"></a>00196     <span class="keyword">public</span>:
<a name="l00203"></a>00203         <a class="code" href="classOgre_1_1AnimationControllerFunction.html" title="Predefined controller function for dealing with animation.">AnimationControllerFunction</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> sequenceTime, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeOffset = 0.0f);
<a name="l00204"></a>00204 
<a name="l00207"></a>00207         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00208"></a>00208 
<a name="l00210"></a>00210         <span class="keywordtype">void</span> setTime(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> timeVal);
<a name="l00212"></a>00212         <span class="keywordtype">void</span> setSequenceTime(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> seqVal);
<a name="l00213"></a>00213     };
<a name="l00214"></a>00214 
<a name="l00215"></a>00215     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00218"></a><a class="code" href="classOgre_1_1ScaleControllerFunction.html">00218</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1ScaleControllerFunction.html" title="Predefined controller function which simply scales an input to an output value.">ScaleControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>&lt;Real&gt;
<a name="l00219"></a>00219     {
<a name="l00220"></a>00220     <span class="keyword">protected</span>:
<a name="l00221"></a><a class="code" href="classOgre_1_1ScaleControllerFunction.html#a4dd32e9e1e057b4abf391fa5eb4f89e5">00221</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1ScaleControllerFunction.html#a4dd32e9e1e057b4abf391fa5eb4f89e5">mScale</a>;
<a name="l00222"></a>00222     <span class="keyword">public</span>:
<a name="l00230"></a>00230         <a class="code" href="classOgre_1_1ScaleControllerFunction.html" title="Predefined controller function which simply scales an input to an output value.">ScaleControllerFunction</a>(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> scalefactor, <span class="keywordtype">bool</span> deltaInput);
<a name="l00231"></a>00231 
<a name="l00234"></a>00234         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236     };
<a name="l00237"></a>00237 
<a name="l00238"></a>00238     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00258"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html">00258</a> <span class="comment"></span>    <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html" title="Predefined controller function based on a waveform.">WaveformControllerFunction</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1ControllerFunction.html" title="Subclasses of this class are responsible for performing a function on an input value for a Controller...">ControllerFunction</a>&lt;Real&gt;
<a name="l00259"></a>00259     {
<a name="l00260"></a>00260     <span class="keyword">protected</span>:
<a name="l00261"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#a4d20ceeb97414c820c091c2d2d1cb1ba">00261</a>         <a class="code" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#a4d20ceeb97414c820c091c2d2d1cb1ba">mWaveType</a>;
<a name="l00262"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#aef4d97d6aa5570d4a4dcaeb11dd3fb34">00262</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#aef4d97d6aa5570d4a4dcaeb11dd3fb34">mBase</a>;
<a name="l00263"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#a293bcc15c3553f687b890ad711aab0b7">00263</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#a293bcc15c3553f687b890ad711aab0b7">mFrequency</a>;
<a name="l00264"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#a3de22fc6e6c69377856b2f97f47b299b">00264</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#a3de22fc6e6c69377856b2f97f47b299b">mPhase</a>;
<a name="l00265"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#aa47e62b3fc8bf48e93e6fd280085b57b">00265</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#aa47e62b3fc8bf48e93e6fd280085b57b">mAmplitude</a>;
<a name="l00266"></a><a class="code" href="classOgre_1_1WaveformControllerFunction.html#a649691c7cb6c4c4b10547ca66d38df7e">00266</a>         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> <a class="code" href="classOgre_1_1WaveformControllerFunction.html#a649691c7cb6c4c4b10547ca66d38df7e">mDutyCycle</a>;
<a name="l00267"></a>00267 
<a name="l00269"></a>00269         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getAdjustedInput(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> input);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271     <span class="keyword">public</span>:
<a name="l00279"></a>00279         <a class="code" href="classOgre_1_1WaveformControllerFunction.html" title="Predefined controller function based on a waveform.">WaveformControllerFunction</a>(<a class="code" href="group__General.html#gabf2e0412a783a6f708ca1a58abb45c1b" title="Enumerates the wave types usable with the Ogre engine.">WaveformType</a> wType, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> base = 0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> frequency = 1, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> phase = 0, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> amplitude = 1, <span class="keywordtype">bool</span> deltaInput = <span class="keyword">true</span>, <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> dutyCycle = 0.5);
<a name="l00280"></a>00280 
<a name="l00283"></a>00283         <a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> calculate(<a class="code" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> source);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     };
<a name="l00286"></a>00286     <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00290"></a>00290 <span class="comment"></span>}
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:51
</p>
</body>
</html>
